/*
    Stream Capture
    Copyright (C) 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/



#include "checkforupdates.h"
#include "streamcapture.h"





void CheckForUpdates::check(std::string sprak)
{
    if (sprak == "en_US")
        applicationHomepage = APPLICATION_HOMEPAGE_ENG;
    else
        applicationHomepage = APPLICATION_HOMEPAGE;

    QUrl url(VERSION_PATH);
    QNetworkAccessManager *nam = new QNetworkAccessManager(this);
    QNetworkReply  *reply;
    reply = nam->get(QNetworkRequest(url));


    QObject::connect(nam, SIGNAL(finished(QNetworkReply*)),this, SLOT(checkForUpdates(QNetworkReply*)));


}

void CheckForUpdates::checkForUpdates(QNetworkReply *reply)
{
    QByteArray bytes = reply->readAll();  // bytes
    QString version = (QString) bytes; // string
    version = version.trimmed();
    if (version == "")
        QMessageBox::critical(this,APPLICATION_NAME " " VERSION, tr("No Internet connection was found.\nPlease check your Internet settings or firewall."));
    else
   {
    if (VERSION != version)
        QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nWhere is a newer version of ")+ APPLICATION_NAME + tr("<br>Please download from<p><a href=")+ applicationHomepage + ">" + applicationHomepage + "</a></p>");
    else
        QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nYou have the latest version of ")+ APPLICATION_NAME);

   }


}

CheckForUpdates::~CheckForUpdates()
{
    delete this;
}
