/*
    Stream Capture
    Copyright (C) 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include "downloads.h"
#include "ui_downloads.h"

Downloads::Downloads(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Downloads)
{
    setStartConfig();
    lasin();

connect(ui->btnExit, SIGNAL(clicked()), this, SLOT(close()));
connect(ui->btnRemove, SIGNAL(clicked()), this, SLOT(remove()));
connect(ui->btnExport, SIGNAL(clicked()), this, SLOT(exportera()));
connect(ui->btnImport, SIGNAL(clicked()), this, SLOT(importera()));


}

// private slots
void Downloads::importera()
{

    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    QString sokvag;
    std::string s = k->getConf("import_path");
    if (s == "nothing")
      {
          k->newConf("import_path","");

      }


    QString qs = QString::fromStdString(s);


    QFileInfo info(qs);
     if (info.isReadable())
           sokvag = qs;
     else
     {
         sokvag = QDir::homePath();
     }

    QFileDialog *dialog = new QFileDialog(this, tr("Open download list"),
                                               sokvag,
                                               tr("Text file (*.txt)"));

    dialog->setAcceptMode(QFileDialog::AcceptOpen);
    dialog->setFileMode(QFileDialog::AnyFile);
    dialog->selectFile("streamCaptureExport.txt");

   if (dialog->exec())
   {


       QDir dir;
       dir = dialog->directory();
       QString directoryName = dir.path();
       k->setConf("import_path",directoryName.toStdString());
       delete k;

       QStringList fileNames = dialog->selectedFiles();
       lasin(QDir::toNativeSeparators(fileNames[0]));
       model->clear();
       lasin();



  }
   else
       delete k;
}

void Downloads::exportera()
{

         QModelIndexList valdaIndexes = ui->downloadsView->selectionModel()->selectedIndexes();
         qSort(valdaIndexes.begin(), valdaIndexes.end());
         if (valdaIndexes.isEmpty())
             QMessageBox::warning(this, APPLICATION_NAME " " VERSION,tr("Please select one or more downloads to export."));
         else
         {
         QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
         k2 = new Config2(conf_file_name2);
         std::vector<std::string> *vkt = new std::vector<std::string>;



         QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
         k = new Config(conf_file_name);
         QString sokvag;
         std::string s = k->getConf("export_path");
         if (s == "nothing")
           {
               k->newConf("export_path","");

           }


         QString qs = QString::fromStdString(s);


         QFileInfo info(qs);
          if (info.isReadable())
                sokvag = qs;
          else
          {
              sokvag = QDir::homePath();
          }

         QFileDialog *dialog = new QFileDialog(this, tr("Save download list"),
                                                    sokvag,
                                                    tr("Text file (*.txt)"));

         dialog->setAcceptMode(QFileDialog::AcceptSave);
         dialog->setFileMode(QFileDialog::AnyFile);
         dialog->selectFile("streamCaptureExport.txt");

        if (dialog->exec())
        {
            QStringList fileNames = dialog->selectedFiles();
            QDir dir;
            QVariant qvv;
            QString qs;
            std::string s,s2;
            dir = dialog->directory();
            QString directoryName = dir.path();
            k->setConf("export_path",directoryName.toStdString());
            delete k;
            int pos0, pos1;
            std::string tmp, tmp2;
            std::string temp;
            for(int j = valdaIndexes.count() - 1; j > -1; --j)
            {

                    qvv = valdaIndexes.at(j).data();
                    qs = qvv.toString();

                    s = strippadString2(qs);

                    // Remove all white spaces
                    temp="";
                    for (unsigned int i = 0; i < s.length(); i++)
                        if (s[i] != ' ') temp += s[i];
                    s = temp;




                    s2 = k2->getConf2(s);
                    pos0 = s2.find_first_of("=");
                    if (pos0 != (-1))
                    {
                        s2 = s2.substr(pos0,s2.size());

                    }

                    pos0=0;
                    pos0 = s.find_first_of("=");
                    tmp = s.substr(0,pos0);
                   // QMessageBox::information(this,"TEST",QString::fromStdString(s2));
                   // s2.erase(0,pos0);
                    pos1 = tmp.find_last_of("/");

                    if (pos1 != (-1))
                    {
                        s = tmp.substr(pos1,tmp.size());

                       // QMessageBox::information(this,"/",QString::fromStdString(s));
                    }

                    pos1 = tmp.find_last_of("#");
                    if (pos1 != (-1))
                    {
                        s = tmp.substr(pos1+1,tmp.size());

                       // QMessageBox::information(this,"#",QString::fromStdString(s));
                    }
                    vkt->push_back(s+s2);
                      // QMessageBox::information(this,"s2",QString::fromStdString(s2));


            }
         std::string *filnamn = new std::string;
         *filnamn = fileNames[0].toStdString();

         bool lyckades = k2->newFile(vkt,filnamn);
         if (lyckades == false)
             QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("Unable to export the file. Check your file permissions."));
         delete k2;
         delete vkt;
         delete filnamn;

        }
        else
            delete k;

         }



}

void Downloads::remove()
{
  //  QMessageBox::information(this,"TEST","Help!");



     //  ui->downloadsView->setUpdatesEnabled(false);

       QModelIndexList valdaIndexes = ui->downloadsView->selectionModel()->selectedIndexes();
       //int strlk = model->rowCount();
       qSort(valdaIndexes.begin(), valdaIndexes.end());

       QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
       k2 = new Config2(conf_file_name2);

       QVariant qvv;
       QString qs;
       std::string temp, s;

           for(int j = valdaIndexes.count() - 1; j > -1; --j)
           {

                   qvv = valdaIndexes.at(j).data();
                   qs = qvv.toString();
                   s = strippadString2(qs);
                   // Remove all white spaces
                   temp="";
                   for (unsigned int i = 0; i < s.length(); i++)
                       if (s[i] != ' ') temp += s[i];
                   s = temp;


                  k2->deleteConf2(s);
                  model->removeRow(valdaIndexes.at(j).row());

           }

      delete k2;
      ui->downloadsView->setUpdatesEnabled(true);



}

// private

std::string Downloads::strippadString2(QString in)
{
    int pos0;
    std::string s;
    QString tmp, ut;
    pos0=in.indexOf('=');


    if (in.mid(0,8) != "Imported")
    {
        tmp = in.mid(0,19);
        QDateTime dt = QDateTime::fromString(tmp,"yyyy-MM-dd hh:mm:ss");
        uint t = dt.toTime_t();
        tmp.setNum(t);
        tmp = tmp.trimmed();
        in = in.remove(0,19);
        s = (tmp+'#'+in).toStdString();

    }
    else
    {
        in.remove(0,9);
        pos0=in.indexOf('=');
        QString ut = in.mid(0,pos0);
        s = ut.toStdString();

    }



    return s;


}

std::string Downloads::strippadString(QString in)
{
    int pos0;
    std::string s;
    QString ut;
    pos0=in.indexOf('=');


    if (in.mid(0,8) != "Imported")
    {
        ut = in.mid(0,19);
        QDateTime dt = QDateTime::fromString(ut,"yyyy-MM-dd hh:mm:ss");
        uint t = dt.toTime_t();
        ut.setNum(t);
        s = ut.toStdString();

    }
    else
    {
        in.remove(0,9);
        pos0=in.indexOf('=');
        QString ut = in.mid(0,pos0);
        s = ut.toStdString();

    }




    return s;


}

void Downloads::lasin(QString filepath)
{

    k2 = new Config2;
    std::vector<std::string> *vkt = new std::vector<std::string>;
    string in = filepath.toStdString();
    vkt = k2->getAllConf(in);
    delete k2;
    QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
    k2 = new Config2(conf_file_name2);
    std::string namn, varde, tmp;
    uint t;
    vector<string>::iterator it;
    for (it=vkt->begin();it<vkt->end();it++)
    {




          tmp=*it;
          t=tmp.find_first_of('=');
          namn=tmp.substr(0,t);
          varde=tmp.substr(t+1,tmp.size());


           k2->newConf(namn,varde);

    }

    delete k2;

}

void Downloads::lasin()
{
    QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
    k2 = new Config2(conf_file_name2);
    std::vector<std::string> *vkt = new std::vector<std::string>;
    vkt = k2->getAllConf();
    sort(vkt->begin(),vkt->end());
    delete k2;

    QString s, stmp, stid, tid, snamn;
    QDateTime dt;
    int pos0, pos1, pos2;

    QStandardItem *item;

    vector<string>::reverse_iterator rit;
    for (rit=vkt->rbegin() ; rit < vkt->rend(); ++rit)
    {
        s = QString::fromStdString(*rit);
        pos0 = s.indexOf('#');


        if (pos0 < 0)
        {
            pos1 = s.indexOf('=');

            snamn = s.mid(0,pos1);


            item = new QStandardItem();
            item->setData(tr("Imported: ") + snamn, Qt::DisplayRole );
            item->setEditable(false);
            model->appendRow(item);



        }
        else
        {

        pos1 = s.indexOf('=');

        stmp = s.mid(pos0+1,pos1-pos0-1);
        pos2 = stmp.lastIndexOf('/');
        snamn = stmp.mid(pos2+1,-1);
        stid = s.mid(0,pos0);



        uint sec = stid.toInt();
        dt = QDateTime::fromTime_t(sec);
        tid = dt.toString("yyyy-MM-dd hh:mm:ss");



           item = new QStandardItem();
           item->setData( tid+"  "+snamn, Qt::DisplayRole );
           item->setEditable(false);
           model->appendRow(item);
        }

     }
}

void Downloads::setStartConfig()
{


    ui->setupUi(this);
    this->setWindowTitle(APPLICATION_NAME " " VERSION);
    ui->downloadsView->setSelectionBehavior(QAbstractItemView::SelectRows);

    model = new QStandardItemModel(ui->downloadsView);
    ui->downloadsView->setModel( model );

    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    std::stringstream ss;
    std::string s = k->getConf("x_lage_d");
    if (s == "nothing")
      {
        k->newConf("x_lage_d","100");
        s = "100";
      }
    int x=0;
    ss << s;
    ss >> x;
    ss.clear();
    s = k->getConf("y_lage_d");
    if (s == "nothing")
      {
        k->newConf("y_lage_d","100");
        s = "100";
      }
    int y=0;
    ss << s;
    ss >> y;
    ss.clear();

    s = k->getConf("max_downloads");
    if (s == "nothing")
      {
        k->newConf("max_downloads","20");
        s ="20";
      }
    int max_downloads=0;
    ss << s;
    ss >> max_downloads;
    ss.clear();


    this->setGeometry(x,y,920,338);
    this->setFixedSize(920,338);

    ui->spbMax->setValue(max_downloads);
    delete k;

}

void Downloads::setEndConfig()
{

    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    QRect rect;
    rect=this->geometry();

    int x_lage=rect.x();
    int y_lage=rect.y();

    std::stringstream ss;
    std::string str;

    ss.clear();

    ss << x_lage;
    ss >> str;
    k->setConf("x_lage_d",str);

    ss.clear();

    ss << y_lage;
    ss >> str;
    k->setConf("y_lage_d",str);

    ss.clear();

    int max_downloads = ui->spbMax->value();
    ss << max_downloads;
    ss >> str;
    k->setConf("max_downloads",str);


    delete k;


}

void Downloads::closeEvent(QCloseEvent *event)
{
    setEndConfig();
    event->accept();
    close();
}

Downloads::~Downloads()
{
    setEndConfig();
    delete this;
}
